//
// Created by huli on 2021/3/2.
//

#include "catcher_task.h"


Catcher_task::Catcher_task()
{
	//构造函数锁定任务类型为 LOCATE_MANGER_TASK，后续不允许更改
	m_task_type = CATCHER_TASK;
	m_task_statu = TASK_CREATED;
	m_task_statu_information.clear();
	m_task_error_manager.error_manager_clear_all();

	m_request_x = 0;				//机器人坐标x轴,
	m_request_y = 0;				//机器人坐标y轴,
	m_request_b = 0;				//机器人坐标b轴, 旋转范围80~280
	m_request_z = 0;				//机器人坐标z轴,
	m_request_space_id = 0;			//机器人空间位置的id.
	m_request_d1 = 0;				//机器人坐标d1轴, 机器人抓车杆纵向移动(前轮抓杆)
	m_request_d2 = 0;				//机器人坐标d2轴, 机器人抓车杆纵向移动(后轮抓杆)
	m_request_wheelbase = 0;		//机器人抓车杆前后轮距.
	m_request_clamp_motion = E_CLAMP_NO_ACTION;		//机器人夹车杆. 0=无动作，1=夹紧，2=松开

	m_respons_status = RESPONS_WORKING;			//指令完成状态, 机器人答复指令, 返回任务完成的情况
	m_respons_x = 0;				//机器人坐标x轴,
	m_respons_y = 0;				//机器人坐标y轴,
	m_respons_b = 0;				//机器人坐标b轴, 旋转范围80~280
	m_respons_z = 0;				//机器人坐标z轴,
	m_respons_space_id = 0;			//机器人空间位置的id.
	m_respons_d1 = 0;				//机器人坐标d1轴, 机器人抓车杆纵向移动(前轮抓杆)
	m_respons_d2 = 0;				//机器人坐标d2轴, 机器人抓车杆纵向移动(后轮抓杆)
	m_respons_wheelbase = 0;		//机器人抓车杆前后轮距.
	m_respons_clamp_motion = E_CLAMP_NO_ACTION;		//机器人夹车杆. 0=无动作，1=夹紧，2=松开

}

Catcher_task::~Catcher_task()
{

}











