//
// huli  test   20200223
//

#include <iostream>
#include "./error_code/error_code.h"
//#include "LogFiles.h"
#include <glog/logging.h>

#include "./communication/communication_socket_base.h"

#include "./tool/thread_pool.h"
#include "./system/system_communication.h"
#include "./system/system_executor.h"

#include "./dispatch/dispatch_manager.h"
#include "./dispatch/dispatch_communication.h"


#include "./tool/common_data.h"



#include <algorithm>    // std::for_each


#define LIVOX_NUMBER	     2


GOOGLE_GLOG_DLL_DECL void shut_down_logging(const char* data, int size)
{
	time_t tt;
	time( &tt );
	tt = tt + 8*3600;  // transform the time zone
	tm* t= gmtime( &tt );
	char buf[255]={0};
	sprintf(buf,"./%d%02d%02d-%02d%02d%02d-dump.txt",
			t->tm_year + 1900,
			t->tm_mon + 1,
			t->tm_mday,
			t->tm_hour,
			t->tm_min,
			t->tm_sec);

	FILE* tp_file=fopen(buf,"w");
	fprintf(tp_file,data,strlen(data));
	fclose(tp_file);

}

#include <chrono>
using namespace std;

void myfunction (int i) {  // function:
	std::cout << ' ' << i;
}


class AAA
{
public:
	int a;
};

class BBB:public AAA
{
public:
	int b;
};

class CCC:public AAA
{
public:
	int c;
};



int main(int argc,char* argv[])
{

	message::Dispatch_plan_request_msg		m_dispatch_plan_request_msg;		//2调度总规划的请求, 用于启动整个调度算法(调度管理->调度算法)

	m_dispatch_plan_request_msg.mutable_base_info()->set_msg_type(message::Message_type::eDispatch_plan_request_msg);
	m_dispatch_plan_request_msg.mutable_base_info()->set_timeout_ms(50);
	m_dispatch_plan_request_msg.mutable_base_info()->set_sender(message::Communicator::eDispatch_mamager);
	m_dispatch_plan_request_msg.mutable_base_info()->set_receiver(message::Communicator::eDispatch_control);
	m_dispatch_plan_request_msg.set_command_key("m_command_key");
//
//std::cout << " huli test :::: " << " 1231231231231231 = " << m_dispatch_plan_request_msg.has_dispatch_source() << std::endl;
//	m_dispatch_plan_request_msg.set_dispatch_source(50);
//	std::cout << " huli test :::: " << " 1231231231231231 = " << m_dispatch_plan_request_msg.has_dispatch_source() << std::endl;
//
//	m_dispatch_plan_request_msg.clear_dispatch_source();
//	std::cout << " huli test :::: " << " 1231231231231231 = " << m_dispatch_plan_request_msg.has_dispatch_source() << std::endl;

	int aaa =  m_dispatch_plan_request_msg.dispatch_task_type();
	std::cout << " huli test :::: " << " aaa = " << aaa << std::endl;

	m_dispatch_plan_request_msg.DebugString();
	std::cout << " huli test :::: " << " m_dispatch_plan_request_msg.DebugString() = " << m_dispatch_plan_request_msg.DebugString() << std::endl;

	return 0;



	const char* logPath = "./";
	google::InitGoogleLogging("LidarMeasurement");
	google::SetStderrLogging(google::INFO);
	google::SetLogDestination(0, logPath);
	google::SetLogFilenameExtension("zxlog");
	google::InstallFailureSignalHandler();
	google::InstallFailureWriter(&shut_down_logging);
	FLAGS_colorlogtostderr = true;        // Set log color
	FLAGS_logbufsecs = 0;                // Set log output speed(s)
	FLAGS_max_log_size = 1024;            // Set max log file size(GB)
	FLAGS_stop_logging_if_full_disk = true;


	Error_manager t_error;
	t_error = Dispatch_communication::get_instance_references().communication_init();

	Dispatch_manager::get_instance_references().dispatch_manager_init(0);
	std::cout << "Dispatch_manager = " << Dispatch_manager::get_instance_references().get_dispatch_manager_status() << std::endl;

	System_executor::get_instance_references().system_executor_init(8);
	std::cout << "System_executor = " << System_executor::get_instance_references().get_system_executor_status() << std::endl;
	System_communication::get_instance_references().communication_init();


	return 0;

















//	Error_manager t_error;
	t_error = Dispatch_communication::get_instance_references().communication_init();


	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::cout << "Dispatch_communication = " << Dispatch_communication::get_instance_references().get_status() << std::endl;
	std::this_thread::sleep_for(std::chrono::seconds(2));
	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::cout << "Dispatch_communication = " << Dispatch_communication::get_instance_references().get_status() << std::endl;

	std::cout << " ---------------------------------------------------" << std::endl;
	std::cout << " ---------------------------------------------------" << std::endl;





/*

	Catcher t_catcher;
	t_error = t_catcher.dispatch_device_base_init(1);
	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::this_thread::sleep_for(std::chrono::seconds(2));

	std::shared_ptr<Task_Base> tp_task_Base1(new Catcher_task);
	Catcher_task * tp_catcher_task = (Catcher_task *)tp_task_Base1.get();
	tp_catcher_task->task_init(NULL,std::chrono::milliseconds(15000));
	tp_catcher_task->m_request_key = "nfddsfgkjvbds";
	tp_catcher_task->m_request_x = 500;
	tp_catcher_task->m_request_y = 600;
	tp_catcher_task->m_request_b = 80;
	tp_catcher_task->m_request_z = 700;
	tp_catcher_task->m_request_d1 = 355;
	tp_catcher_task->m_request_d2 = 455;
	tp_catcher_task->m_request_wheelbase = 1255;
	tp_catcher_task->m_request_clamp_motion = Catcher_task::E_CLAMP_TIGHT;
	t_error = t_catcher.execute_task(tp_task_Base1, Dispatch_device_base::E_ONE_LEVEL);
	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::cout << " ---------------------------------------------------" << std::endl;

	char zxczxcxzc1 ;
	std::cin >> zxczxcxzc1 ;

	while ( 1 )
	{
		std::cout << " huli test :::: " << "  ===================================== "   << std::endl;
		std::cout << " huli test :::: " << " tp_catcher_task->get_task_statu = " << tp_catcher_task->get_task_statu() << std::endl;
		std::cout << " huli test :::: " << " tp_catcher_task->m_respons_status = " << tp_catcher_task->m_respons_status << std::endl;

		std::cout << " huli test :::: " << " m_respons_key = " << tp_catcher_task->m_respons_key << std::endl;
		std::cout << " huli test :::: " << " m_respons_status = " << tp_catcher_task->m_respons_status << std::endl;
		std::cout << " huli test :::: " << " m_respons_x = " << tp_catcher_task->m_respons_x << std::endl;
		std::cout << " huli test :::: " << " m_respons_y = " << tp_catcher_task->m_respons_y << std::endl;
		std::cout << " huli test :::: " << " m_respons_b = " << tp_catcher_task->m_respons_b << std::endl;
		std::cout << " huli test :::: " << " m_respons_z = " << tp_catcher_task->m_respons_z << std::endl;
		std::cout << " huli test :::: " << " m_respons_d1 = " << tp_catcher_task->m_respons_d1 << std::endl;
		std::cout << " huli test :::: " << " m_respons_d2 = " << tp_catcher_task->m_respons_d2 << std::endl;
		std::cout << " huli test :::: " << " m_respons_wheelbase = " << tp_catcher_task->m_respons_wheelbase << std::endl;
		std::cout << " huli test :::: " << " m_respons_clamp_motion = " << tp_catcher_task->m_respons_clamp_motion << std::endl;
		std::cout << " ---------------------------------------------------" << std::endl;




		std::cout << " huli test :::: " << " *********************************************** = " << std::endl;
		std::cout << " huli test :::: " << " t_carrier_base.get_carrier_status() = " << t_catcher.get_dispatch_device_status() << std::endl;
		int heat = t_catcher.m_last_heartbeat;
		std::cout << " huli test :::: " << " m_last_heartbeat = " << heat << std::endl;
		std::cout << " huli test :::: " << " m_actual_device_status = " << t_catcher.m_actual_device_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_load_status = " << t_catcher.m_actual_load_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_x = " << t_catcher.m_actual_x << std::endl;
		std::cout << " huli test :::: " << " m_actual_y = " << t_catcher.m_actual_y << std::endl;
		std::cout << " huli test :::: " << " m_actual_b = " << t_catcher.m_actual_b << std::endl;
		std::cout << " huli test :::: " << " m_actual_z = " << t_catcher.m_actual_z << std::endl;
		std::cout << " huli test :::: " << " m_actual_d1 = " << t_catcher.m_actual_d1 << std::endl;
		std::cout << " huli test :::: " << " m_actual_d2 = " << t_catcher.m_actual_d2 << std::endl;
		std::cout << " huli test :::: " << " m_actual_clamp_motion1 = " << t_catcher.m_actual_clamp_motion1 << std::endl;
		std::cout << " huli test :::: " << " m_actual_clamp_motion2 = " << t_catcher.m_actual_clamp_motion2 << std::endl;
		std::cout << " huli test :::: " << " m_actual_clamp_motion3 = " << t_catcher.m_actual_clamp_motion3 << std::endl;
		std::cout << " huli test :::: " << " m_actual_clamp_motion4 = " << t_catcher.m_actual_clamp_motion4 << std::endl;
		std::cout << " huli test :::: " << " m_actual_error_code = " <<  std::endl;
		for (int i = 0; i < 50; ++i)
		{
			printf("0x%x ", t_catcher.m_actual_error_code[i]);
		}
		std::cout <<  std::endl;

		std::cout << " huli test :::: " << " m_actual_warning_code = " <<  std::endl;
		for (int i = 0; i < 50; ++i)
		{
			printf("0x%x ", t_catcher.m_actual_warning_code[i]);
		}
		std::cout <<  std::endl;
		std::cout << " huli test :::: " << " m_actual_error_description = " << t_catcher.m_actual_error_description << std::endl;

		std::cout << " huli test :::: " << " *********************************************** = " << std::endl;




		std::this_thread::sleep_for(std::chrono::milliseconds(1000));

	}

*/




	Carrier t_carrier;
	t_error = t_carrier.dispatch_device_base_init(0);
	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::this_thread::sleep_for(std::chrono::seconds(2));

	std::shared_ptr<Task_Base> tp_task_Base2(new Carrier_task);
	Carrier_task * tp_carrier_task = (Carrier_task *)tp_task_Base2.get();
	tp_carrier_task->task_init(NULL,std::chrono::milliseconds(15000));
	tp_carrier_task->m_request_key = "fimfyuiyuifjh";
	tp_carrier_task->m_request_x = 333;
	tp_carrier_task->m_request_y = 444;
	tp_carrier_task->m_request_z = 555;
	tp_carrier_task->m_request_y1 = 333;
	tp_carrier_task->m_request_y2 = 444;
	tp_carrier_task->m_request_clamp_motion = Carrier_task::E_CLAMP_LOOSE;
	tp_carrier_task->m_request_joint_motion_x = Carrier_task::E_JOINT_HOLD_OUT;
	tp_carrier_task->m_request_joint_motion_y = Carrier_task::E_JOINT_HOLD_OUT;
	tp_carrier_task->m_request_space_id = 555;
	tp_carrier_task->m_request_floor_id = 555;
	tp_carrier_task->m_request_wheelbase = 555;

	t_error = t_carrier.execute_task(tp_task_Base2, Dispatch_device_base::E_ONE_LEVEL);
	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::cout << " ---------------------------------------------------" << std::endl;

	char zxczxcxzc2 ;
	std::cin >> zxczxcxzc2 ;

	while ( 1 )
	{
		std::cout << " huli test :::: " << "  ===================================== "   << std::endl;
		std::cout << " huli test :::: " << " tp_carrier_task->get_task_statu = " << tp_carrier_task->get_task_statu() << std::endl;
		std::cout << " huli test :::: " << " tp_carrier_task->m_respons_status = " << tp_carrier_task->m_respons_status << std::endl;


		std::cout << " huli test :::: " << " m_respons_key = " << tp_carrier_task->m_respons_key << std::endl;
		std::cout << " huli test :::: " << " m_respons_status = " << tp_carrier_task->m_respons_status << std::endl;
		std::cout << " huli test :::: " << " m_respons_x = " << tp_carrier_task->m_respons_x << std::endl;
		std::cout << " huli test :::: " << " m_respons_y = " << tp_carrier_task->m_respons_y << std::endl;
		std::cout << " huli test :::: " << " m_respons_z = " << tp_carrier_task->m_respons_z << std::endl;
		std::cout << " huli test :::: " << " m_respons_y1 = " << tp_carrier_task->m_respons_y1 << std::endl;
		std::cout << " huli test :::: " << " m_respons_y2 = " << tp_carrier_task->m_respons_y2 << std::endl;
		std::cout << " huli test :::: " << " m_respons_clamp_motion = " << tp_carrier_task->m_respons_clamp_motion << std::endl;
		std::cout << " huli test :::: " << " m_respons_joint_motion_x = " << tp_carrier_task->m_respons_joint_motion_x << std::endl;
		std::cout << " huli test :::: " << " m_respons_joint_motion_y = " << tp_carrier_task->m_respons_joint_motion_y << std::endl;
		std::cout << " huli test :::: " << " m_respons_space_id = " << tp_carrier_task->m_respons_space_id << std::endl;
		std::cout << " huli test :::: " << " m_respons_floor_id = " << tp_carrier_task->m_respons_floor_id << std::endl;
		std::cout << " huli test :::: " << " m_respons_wheelbase = " << tp_carrier_task->m_respons_wheelbase << std::endl;
		std::cout << " ---------------------------------------------------" << std::endl;





		std::cout << " huli test :::: " << " *********************************************** = " << std::endl;
		std::cout << " huli test :::: " << " t_carrier_base.get_carrier_status() = " << t_carrier.get_dispatch_device_status() << std::endl;
		int heat = t_carrier.m_last_heartbeat;
		std::cout << " huli test :::: " << " m_last_heartbeat = " << heat << std::endl;
		std::cout << " huli test :::: " << " m_actual_device_status = " << t_carrier.m_actual_device_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_load_status = " << t_carrier.m_actual_load_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_x = " << t_carrier.m_actual_x << std::endl;
		std::cout << " huli test :::: " << " m_actual_y = " << t_carrier.m_actual_y << std::endl;
		std::cout << " huli test :::: " << " m_actual_z = " << t_carrier.m_actual_z << std::endl;
		std::cout << " huli test :::: " << " m_actual_y1 = " << t_carrier.m_actual_y1 << std::endl;
		std::cout << " huli test :::: " << " m_actual_y2 = " << t_carrier.m_actual_y2 << std::endl;
		std::cout << " huli test :::: " << " m_actual_clamp_motion1 = " << t_carrier.m_actual_clamp_motion1 << std::endl;
		std::cout << " huli test :::: " << " m_actual_clamp_motion2 = " << t_carrier.m_actual_clamp_motion2 << std::endl;
		std::cout << " huli test :::: " << " m_actual_small_sports_car_motion = " << t_carrier.m_actual_small_sports_car_motion << std::endl;
		std::cout << " huli test :::: " << " m_actual_joint_motion_x1 = " << t_carrier.m_actual_joint_motion_x1 << std::endl;
		std::cout << " huli test :::: " << " m_actual_joint_motion_x2 = " << t_carrier.m_actual_joint_motion_x2 << std::endl;
		std::cout << " huli test :::: " << " m_actual_error_code = " <<  std::endl;
		for (int i = 0; i < 50; ++i)
		{
			printf("0x%x ", t_carrier.m_actual_error_code[i]);
		}
		std::cout <<  std::endl;

		std::cout << " huli test :::: " << " m_actual_warning_code = " <<  std::endl;
		for (int i = 0; i < 50; ++i)
		{
			printf("0x%x ", t_carrier.m_actual_warning_code[i]);
		}
		std::cout <<  std::endl;
		std::cout << " huli test :::: " << " m_actual_error_description = " << t_carrier.m_actual_error_description << std::endl;

		std::cout << " huli test :::: " << " *********************************************** = " << std::endl;



		std::this_thread::sleep_for(std::chrono::milliseconds(1000));

	}






	Passageway t_passageway;
	t_error = t_passageway.dispatch_device_base_init(1);
	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::this_thread::sleep_for(std::chrono::seconds(2));

	std::shared_ptr<Task_Base> tp_task_Base3(new Passageway_task);
	Passageway_task * tp_passageway_task = (Passageway_task *)tp_task_Base3.get();
	tp_passageway_task->task_init(NULL,std::chrono::milliseconds(15000));
	tp_passageway_task->m_request_key = "ABCDEF";
	tp_passageway_task->m_request_inside_door_motion = Passageway_task::DOOR_OPEN;
	tp_passageway_task->m_request_outside_door_motion = Passageway_task::DOOR_CLOSE;
	tp_passageway_task->m_request_turntable_direction = Passageway_task::TURNTABLE_DIRECTION_OUTSIDE;

	t_error = t_passageway.execute_task(tp_task_Base3, Dispatch_device_base::E_ONE_LEVEL);
	std::cout << " huli test :::: " << " t_error = " << t_error << std::endl;
	std::cout << " ---------------------------------------------------" << std::endl;

	char zxczxcxzc3 ;
	std::cin >> zxczxcxzc3 ;

	while ( 1 )
	{
		std::cout << " huli test :::: " << "  ===================================== "   << std::endl;
		std::cout << " huli test :::: " << " tp_passageway_task->get_task_statu = " << tp_passageway_task->get_task_statu() << std::endl;
		std::cout << " huli test :::: " << " tp_passageway_task->m_respons_status = " << tp_passageway_task->m_respons_status << std::endl;


		std::cout << " huli test :::: " << " m_respons_key = " << tp_passageway_task->m_respons_key << std::endl;
		std::cout << " huli test :::: " << " m_respons_status = " << tp_passageway_task->m_respons_status << std::endl;
		std::cout << " huli test :::: " << " m_respons_inside_door_motion = " << tp_passageway_task->m_respons_inside_door_motion << std::endl;
		std::cout << " huli test :::: " << " m_respons_outside_door_motion = " << tp_passageway_task->m_respons_outside_door_motion << std::endl;
		std::cout << " huli test :::: " << " m_respons_turntable_direction = " << tp_passageway_task->m_respons_turntable_direction << std::endl;
		std::cout << " ---------------------------------------------------" << std::endl;





		std::cout << " huli test :::: " << " *********************************************** = " << std::endl;
		std::cout << " huli test :::: " << " t_passageway_base.get_passageway_status() = " << t_passageway.get_dispatch_device_status() << std::endl;
		int heat = t_passageway.m_last_heartbeat;
		std::cout << " huli test :::: " << " m_last_heartbeat = " << heat << std::endl;
		std::cout << " huli test :::: " << " m_actual_device_status = " << t_passageway.m_actual_device_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_inside_load_status = " << t_passageway.m_actual_inside_load_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_outside_load_status = " << t_passageway.m_actual_outside_load_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_front_overstep_the_boundary = " << t_passageway.m_actual_front_overstep_the_boundary << std::endl;
		std::cout << " huli test :::: " << " m_actual_back_overstep_the_boundary = " << t_passageway.m_actual_back_overstep_the_boundary << std::endl;
		std::cout << " huli test :::: " << " m_actual_height_overstep_the_boundary = " << t_passageway.m_actual_height_overstep_the_boundary << std::endl;
		std::cout << " huli test :::: " << " m_actual_outside_door_sensor = " << t_passageway.m_actual_outside_door_sensor << std::endl;
		std::cout << " huli test :::: " << " m_actual_inside_door_motion = " << t_passageway.m_actual_inside_door_motion << std::endl;
		std::cout << " huli test :::: " << " m_actual_outside_door_motion = " << t_passageway.m_actual_outside_door_motion << std::endl;
		std::cout << " huli test :::: " << " m_actual_turntable_load_status = " << t_passageway.m_actual_turntable_load_status << std::endl;
		std::cout << " huli test :::: " << " m_actual_turntable_direction = " << t_passageway.m_actual_turntable_direction << std::endl;
		std::cout << " huli test :::: " << " m_actual_error_code = " <<  std::endl;
		for (int i = 0; i < 50; ++i)
		{
			printf("0x%x ", t_passageway.m_actual_error_code[i]);
		}
		std::cout <<  std::endl;

		std::cout << " huli test :::: " << " m_actual_warning_code = " <<  std::endl;
		for (int i = 0; i < 50; ++i)
		{
			printf("0x%x ", t_passageway.m_actual_warning_code[i]);
		}
		std::cout <<  std::endl;
		std::cout << " huli test :::: " << " m_actual_error_description = " << t_passageway.m_actual_error_description << std::endl;

		std::cout << " huli test :::: " << " *********************************************** = " << std::endl;



		std::this_thread::sleep_for(std::chrono::milliseconds(1000));

	}

























	char ch123 ;
	std::cin >> ch123 ;


	Dispatch_communication::get_instance_references().communication_uninit();
	return 0;














	int t_dispatch_id = 0;
//	std::cin >> t_dispatch_id ;
	if ( argc == 2 )
	{
		std::cout << " huli test :::: " << " argv[1] = " << argv[1] << std::endl;
		t_dispatch_id = atoi(argv[1]);
	}
	std::cout << " huli test :::: " << " t_dispatch_id = " << t_dispatch_id << std::endl;

	Dispatch_manager::get_instance_references().dispatch_manager_init(t_dispatch_id);
	std::cout << "Dispatch_manager = " << Dispatch_manager::get_instance_references().get_dispatch_manager_status() << std::endl;

	System_executor::get_instance_references().system_executor_init(8);
	std::cout << "System_executor = " << System_executor::get_instance_references().get_system_executor_status() << std::endl;
	System_communication::get_instance_references().communication_init();

	char ch ;
	std::cin >> ch ;

	System_communication::get_instance_references().communication_uninit();
	System_executor::get_instance_references().system_executor_uninit();
	Dispatch_manager::get_instance_references().dispatch_manager_uninit();


	return 0;
}